module keyboard_driver(
    input clk,
    input data,
    input rst,
    output [3:0] ox,
    output [3:0] oy,
    output reg click
);
    reg [4:0] byte_count;
    reg [7:0] keycode;
    reg [4:0] x;
    reg [4:0] y;
    reg complete;
    
    assign ox = x >> 1;
    assign oy = y >> 1;
    
    always @(posedge clk or negedge rst) begin
        if (~rst) begin
            byte_count <= 0;
            x <= 0;
            y <= 0;
            click <= 0;
            complete <= 0;
        end else begin
            if (byte_count <= 10)
                byte_count <= byte_count + 1;
            else
                byte_count <= 0;

            if (byte_count == 0)
                keycode <= 0;
            else if (byte_count == 1)
                keycode[0] <= data;
            else if (byte_count == 2)
                keycode[1] <= data;
            else if (byte_count == 3)
                keycode[2] <= data;
            else if (byte_count == 4)
                keycode[3] <= data;
            else if (byte_count == 5)
                keycode[4] <= data;
            else if (byte_count == 6)
                keycode[5] <= data;
            else if (byte_count == 7)
                keycode[6] <= data;
            else if (byte_count == 8)
                keycode[7] <= data;
            else if (byte_count == 9)
                complete <= 1;
            else begin
                complete <= 0;
                keycode <= 0;
                byte_count <= 0;
                click <= 0;
            end
            
            if (complete && keycode == 8'd68) begin
                click <= 1;
            end else if (complete && keycode == 8'd117) begin
                if (y == 0) y <= 0; else y <= y - 1;
            end else if (complete && keycode == 8'd114) begin
                if (y == 18) y <= 18; else y <= y + 1;
            end else if (complete && keycode == 8'd107) begin
                if (x == 0) x <= 0; else x <= x - 1;
            end else if (complete && keycode == 8'd116) begin
                if (x == 18) x <= 18; else x <= x + 1;
            end else begin
                x <= x;
                y <= y;
            end
        end
    end
endmodule
