module matrix_driver(
    input clk,
    input rst,
    input game_over,
    output reg [7:0] dot_row,
    output reg [7:0] dot_col
);
    reg [2:0] row_count;
    
    always @(posedge clk or negedge rst) begin
        if(~rst) begin
            dot_row <= 8'b11111111;
            dot_col <= 8'b00000000;
            row_count <= 3'd0;
	    end else begin
            row_count <= row_count + 1;
            case (row_count)
                3'd0 : dot_row <= 8'b01111111;
                3'd1 : dot_row <= 8'b10111111;
                3'd2 : dot_row <= 8'b11011111;
                3'd3 : dot_row <= 8'b11101111;
                3'd4 : dot_row <= 8'b11110111;
                3'd5 : dot_row <= 8'b11111011;
                3'd6 : dot_row <= 8'b11111101;
                3'd7 : dot_row <= 8'b11111110;
            endcase
            if (~game_over) begin
                row_count <= 8'b00000000;
            end else begin
                case (row_count)
                    3'd0 : dot_col <= 8'b10000001;
                    3'd1 : dot_col <= 8'b01000010;
                    3'd2 : dot_col <= 8'b00100100;
                    3'd3 : dot_col <= 8'b00011000;
                    3'd4 : dot_col <= 8'b00011000;
                    3'd5 : dot_col <= 8'b00100100;
                    3'd6 : dot_col <= 8'b01000010;
                    3'd7 : dot_col <= 8'b10000001;
                endcase
            end
        end
    end
endmodule
