module seven_driver(
    input clk,
    input rst,
    input game_over,
    output [6:0] hundreds,
    output [6:0] tens,
    output [6:0] units
);
    
    reg [9:0] count;
    wire [3:0] display_100;
    wire [3:0] display_10;
    wire [3:0] display_1;
    
    assign display_100 = (count / 100) % 10;
    assign display_10 = (count / 10) % 10;
    assign display_1 = count % 10;
    
    seven_display(display_100, hundreds);
    seven_display(display_10, tens);
    seven_display(display_1, units);
    
    always @(posedge clk or negedge rst) begin
        if(~rst) begin
            count <= 0;
        end else begin
            if (game_over) begin
                count <= count;
            end else begin
                count <= count + 1;
            end
        end
    end
endmodule

module seven_display(
    input [3:0] value,
    output reg [6:0] out
);
    
    always @(value) begin
        case(value)
            0: out <= 7'b1000000;
            1: out <= 7'b1111001;
            2: out <= 7'b0100100;
            3: out <= 7'b0110000;
            4: out <= 7'b0011001;
            5: out <= 7'b0010010;
            6: out <= 7'b0000010;
            7: out <= 7'b1111000;
            8: out <= 7'b0000000;
            9: out <= 7'b0010000;
            10: out <= 7'b0001000;
            11: out <= 7'b0000011;
            12: out <= 7'b1000110;
            13: out <= 7'b0100001;
            14: out <= 7'b0000110;
            15: out <= 7'b0001110;
        endcase
    end
endmodule

